; Autotype demo
; Author : Vortex

.386
.model flat,stdcall
option casemap:none

include	\GeneSys\include\windows.inc
include	Editbox.inc

includelib	\GeneSys\lib\user32.lib
includelib	\GeneSys\lib\kernel32.lib

DlgProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD

IDC_EDIT	equ 1000
ID_TIMER	equ 2000

.data
DlgName	db "MyDialog",0
caption	db 'Autotype demo in the caption ',0
pChar		dd caption

.data?
hInstance   HINSTANCE ?
CommandLine LPSTR ?
hCursor     dd ?

.code

start:

	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
	invoke	DialogBoxParam,hInstance,ADDR DlgName,NULL,ADDR DlgProc,NULL
	invoke	ExitProcess,eax

DlgProc PROC USES esi ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
	.IF uMsg==WM_INITDIALOG
		invoke	LoadCursor,0,IDC_CROSS
		mov		hCursor,eax
		invoke	SetTimer,hWnd,ID_TIMER,150,0

	.ELSEIF uMsg==WM_CLOSE
		invoke	EndDialog,hWnd,NULL
	
	.ELSEIF uMsg==WM_SETCURSOR
		invoke	SetCursor,hCursor

	.ELSEIF uMsg==WM_TIMER
		mov		esi,pChar
		movzx		ebx,BYTE PTR [esi]
		test		ebx,ebx
		.IF ZERO?
			invoke	KillTimer,hWnd,ID_TIMER
		.ELSE
			mov		BYTE PTR [esi],0
			invoke	SendMessage,hWnd,WM_SETTEXT,0,ADDR caption
			mov		BYTE PTR [esi],bl
			inc		pChar
		.ENDIF
	.ELSE
		mov	eax,FALSE
		ret
	.ENDIF

	mov	eax,TRUE
	ret

DlgProc ENDP
END start